#include <poll.h>

#include "stun.h"

int
tunnel(int netfd, int devfd)
{
	unsigned char buf[MAXPAYLOADLEN];
	size_t outlen;
	struct pollfd pfd[2];
	int n;

	pfd[0].fd = netfd;
	pfd[0].events = POLLIN;
	pfd[1].fd = devfd;
	pfd[1].events = POLLIN;
	for (;;) {
		if (poll(pfd, 2, -1) < 0) {
			logwarn("poll failed");
			return -1;
		}

		if (pfd[0].revents & (POLLIN | POLLHUP)) {
			n = netread(netfd, buf, sizeof(buf), &outlen);
			if (n == PKTFAILED)
				return -1;
			else if (n == PKTCOMPLETE)
				devwrite(devfd, buf, outlen);
		}

		if (pfd[1].revents & (POLLIN | POLLHUP)) {
			n = devread(devfd, buf, sizeof(buf));
			if (n > 0)
				if (netwrite(netfd, buf, n, &outlen) == PKTFAILED)
					return -1;
		}
	}
	return 0;
}
